Index: trunk/sources/HeuristicLab.Hive.Server.Console/HeuristicLab.Hive.Server.Console.csproj
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Console/HeuristicLab.Hive.Server.Console.csproj	(revision 1267)
+++ trunk/sources/HeuristicLab.Hive.Server.Console/HeuristicLab.Hive.Server.Console.csproj	(revision 1377)
@@ -73,10 +73,4 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="AddUserForm.cs">
-      <SubType>Form</SubType>
-    </Compile>
-    <Compile Include="AddUserForm.Designer.cs">
-      <DependentUpon>AddUserForm.cs</DependentUpon>
-    </Compile>
     <Compile Include="AddJobForm.cs">
       <SubType>Form</SubType>
@@ -100,7 +94,4 @@
     <Compile Include="HiveServerConsolePlugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <EmbeddedResource Include="AddUserForm.resx">
-      <DependentUpon>AddUserForm.cs</DependentUpon>
-    </EmbeddedResource>
     <EmbeddedResource Include="AddJobForm.resx">
       <DependentUpon>AddJobForm.cs</DependentUpon>
@@ -142,4 +133,8 @@
       <Name>HeuristicLab.Core</Name>
     </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.DataAccess\HeuristicLab.DataAccess.csproj">
+      <Project>{9076697B-C151-46CD-95BC-1D059492B478}</Project>
+      <Name>HeuristicLab.DataAccess</Name>
+    </ProjectReference>
     <ProjectReference Include="..\HeuristicLab.Hive.Contracts\HeuristicLab.Hive.Contracts.csproj">
       <Project>{134F93D7-E7C8-4ECD-9923-7F63259A60D8}</Project>
Index: trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerManagementConsole.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerManagementConsole.Designer.cs	(revision 1267)
+++ trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerManagementConsole.Designer.cs	(revision 1377)
@@ -164,5 +164,4 @@
       this.userToolStripMenuItem1.Size = new System.Drawing.Size(114, 22);
       this.userToolStripMenuItem1.Text = "User";
-      this.userToolStripMenuItem1.Click += new System.EventHandler(this.AddUser_Click);
       // 
       // groupToolStripMenuItem2
@@ -171,5 +170,4 @@
       this.groupToolStripMenuItem2.Size = new System.Drawing.Size(114, 22);
       this.groupToolStripMenuItem2.Text = "Group";
-      this.groupToolStripMenuItem2.Click += new System.EventHandler(this.AddUserGroup_Click);
       // 
       // tcManagementConsole
@@ -337,5 +335,4 @@
       this.tvUserControl.Size = new System.Drawing.Size(139, 346);
       this.tvUserControl.TabIndex = 1;
-      this.tvUserControl.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.OnTVUserControlClicked);
       // 
       // lvUserControl
@@ -349,5 +346,4 @@
       this.lvUserControl.TabIndex = 1;
       this.lvUserControl.UseCompatibleStateImageBehavior = false;
-      this.lvUserControl.Click += new System.EventHandler(this.OnLVUserControlClicked);
       // 
       // ilUserControl
Index: trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerManagementConsole.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerManagementConsole.cs	(revision 1267)
+++ trunk/sources/HeuristicLab.Hive.Server.Console/HiveServerManagementConsole.cs	(revision 1377)
@@ -44,6 +44,4 @@
     private ResponseList<ClientInfo> clientInfo = null;
     private ResponseList<Job> jobs = null;
-    private ResponseList<UserGroup> userGroups = null;
-    private ResponseList<User> usersList = null;
 
     private Dictionary<long, ListViewGroup> clientObjects;
@@ -55,5 +53,4 @@
     private Job currentJob = null;
     private ClientInfo currentClient = null;
-    private User currentUser = null;
     private string nameCurrentJob = "";
     private string nameCurrentClient = "";
@@ -70,5 +67,4 @@
       AddClients();
       AddJobs();
-      AddUsers();
       timerSyncronize.Start();
     }
@@ -182,53 +178,4 @@
 
     /// <summary>
-    /// Adds users to ListView and TreeView
-    /// </summary>
-    private void AddUsers() {
-      try {
-        userGroupsObjects = new Dictionary<long, ListViewGroup>();
-        userListObjects = new Dictionary<long, ListViewItem>();
-        IUserRoleManager userRoleManager =
-          ServiceLocator.GetUserRoleManager();
-
-        userGroups = userRoleManager.GetAllUserGroups();
-
-        lvUserControl.Items.Clear();
-        tvUserControl.Nodes.Clear();
-
-        foreach (UserGroup ug in userGroups.List) {
-          tvUserControl.Nodes.Add(ug.Name);
-          ListViewGroup lvg = new ListViewGroup(ug.Name, HorizontalAlignment.Left);
-
-          foreach (PermissionOwner permOwner in ug.Members) {
-            if (permOwner is User) {
-              User users = permOwner as User;
-              tvUserControl.Nodes[tvUserControl.Nodes.Count - 1].Nodes.Add(users.Name);
-              ListViewItem item = new ListViewItem(users.Name, 0, lvg);
-              lvUserControl.Items.Add(item);
-              userListObjects.Add(users.Id, item);
-            }
-          }
-          lvUserControl.Groups.Add(lvg);
-          userGroupsObjects.Add(ug.Id, lvg);
-
-        } // Users
-        usersList = userRoleManager.GetAllUsers();
-        ListViewGroup lvunsorted = new ListViewGroup("unsorted", HorizontalAlignment.Left);
-        foreach (User u in usersList.List) {
-          tvUserControl.Nodes.Add(u.Name);
-          lvUserControl.Items.Add(new ListViewItem(u.Name, 0, lvunsorted));
-        }
-        lvUserControl.Groups.Add(lvunsorted);
-        if (flagUser) {
-          UserClicked();
-        }
-      }
-      catch (Exception ex) {
-        closeFormEvent(true, true);
-        this.Close();
-      }
-    }
-
-    /// <summary>
     /// if one client is clicked, a panel is opened with the details
     /// </summary>
@@ -320,19 +267,4 @@
     }
 
-    /// <summary>
-    /// if one user is clicked, a panel is opened with the details
-    /// </summary>
-    private void UserClicked() {
-      int i = 0;
-      while (usersList.List[i].Name != nameCurrentUser) {
-        i++;
-      }
-      currentUser = usersList.List[i];
-      scUserControl.Panel2.Controls.Clear();
-      scUserControl.Panel2.Controls.Add(plUserDetails);
-      pbUserControl.Image = ilUserControl.Images[0];
-      lblUserName.Text = currentUser.Id.ToString();
-    }
-
     #region Eventhandlers
     /// <summary>
@@ -368,17 +300,4 @@
       AddClients();
       AddJobs();
-      AddUsers();
-    }
-
-    private void AddUser_Click(object sender, EventArgs e) {
-      AddUserForm newForm = new AddUserForm("User", false);
-      newForm.Show();
-      newForm.addUserEvent += new addDelegate(Refresh);
-    }
-
-    private void AddUserGroup_Click(object sender, EventArgs e) {
-      AddUserForm newForm = new AddUserForm("User", true);
-      newForm.Show();
-      newForm.addUserEvent += new addDelegate(Refresh);                                             
     }
 
@@ -419,26 +338,4 @@
 
     }
-
-    private void OnLVUserControlClicked(object sender, EventArgs e) {
-      nameCurrentUser = lvUserControl.SelectedItems[0].Text;
-      flagUser = true;
-      UserClicked();
-    }
-
-    private void OnTVUserControlClicked(object sender, TreeViewEventArgs e) {
-      bool usergroup = false;
-      foreach (UserGroup ug in userGroups.List) {
-        if (tvUserControl.SelectedNode.Text == ug.Name) {
-          usergroup = true;
-        }
-      }
-      if (usergroup == false) {
-        nameCurrentUser = tvUserControl.SelectedNode.Text;
-        flagUser = true;
-        UserClicked();
-      }
-
-    }
-
 
     private void btnClientClose_Click(object sender, EventArgs e) {
Index: trunk/sources/HeuristicLab.Hive.Server.Console/ServiceLocator.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.Console/ServiceLocator.cs	(revision 1267)
+++ trunk/sources/HeuristicLab.Hive.Server.Console/ServiceLocator.cs	(revision 1377)
@@ -20,8 +20,4 @@
     internal static IJobManager GetJobManager() {
       return GetServerConsoleFacade() as IJobManager;
-    }
-
-    internal static IUserRoleManager GetUserRoleManager() {
-      return GetServerConsoleFacade() as IUserRoleManager;
     }
 