Index: /trunk/sources/HeuristicLab.DataAccess.ADOHelper/HeuristicLab.DataAccess.ADOHelper.csproj
===================================================================
--- /trunk/sources/HeuristicLab.DataAccess.ADOHelper/HeuristicLab.DataAccess.ADOHelper.csproj	(revision 1401)
+++ /trunk/sources/HeuristicLab.DataAccess.ADOHelper/HeuristicLab.DataAccess.ADOHelper.csproj	(revision 1402)
@@ -34,4 +34,20 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x86' ">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x86\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x86' ">
+    <OutputPath>bin\x86\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
   </PropertyGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: /trunk/sources/HeuristicLab.DataAccess/HeuristicLab.DataAccess.csproj
===================================================================
--- /trunk/sources/HeuristicLab.DataAccess/HeuristicLab.DataAccess.csproj	(revision 1401)
+++ /trunk/sources/HeuristicLab.DataAccess/HeuristicLab.DataAccess.csproj	(revision 1402)
@@ -49,4 +49,20 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x86' ">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x86\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x86' ">
+    <OutputPath>bin\x86\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
   </PropertyGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: /trunk/sources/HeuristicLab.Hive.Server.DataAccess/HeuristicLab.Hive.Server.DataAccess.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.DataAccess/HeuristicLab.Hive.Server.DataAccess.csproj	(revision 1401)
+++ /trunk/sources/HeuristicLab.Hive.Server.DataAccess/HeuristicLab.Hive.Server.DataAccess.csproj	(revision 1402)
@@ -34,4 +34,20 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x86' ">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x86\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x86' ">
+    <OutputPath>bin\x86\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
   </PropertyGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: /trunk/sources/HeuristicLab.SA/HeuristicLab.SA.csproj
===================================================================
--- /trunk/sources/HeuristicLab.SA/HeuristicLab.SA.csproj	(revision 1401)
+++ /trunk/sources/HeuristicLab.SA/HeuristicLab.SA.csproj	(revision 1402)
@@ -32,4 +32,20 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x86' ">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x86\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x86' ">
+    <OutputPath>bin\x86\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
   </PropertyGroup>
   <ItemGroup>
Index: /trunk/sources/HeuristicLab.Security.Contracts/HeuristicLab.Security.Contracts.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Security.Contracts/HeuristicLab.Security.Contracts.csproj	(revision 1401)
+++ /trunk/sources/HeuristicLab.Security.Contracts/HeuristicLab.Security.Contracts.csproj	(revision 1402)
@@ -32,4 +32,20 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x86' ">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x86\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x86' ">
+    <OutputPath>bin\x86\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
   </PropertyGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: /trunk/sources/HeuristicLab.Security.DataAccess/HeuristicLab.Security.DataAccess.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Security.DataAccess/HeuristicLab.Security.DataAccess.csproj	(revision 1401)
+++ /trunk/sources/HeuristicLab.Security.DataAccess/HeuristicLab.Security.DataAccess.csproj	(revision 1402)
@@ -32,4 +32,20 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x86' ">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x86\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x86' ">
+    <OutputPath>bin\x86\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
   </PropertyGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: /trunk/sources/HeuristicLab.sln
===================================================================
--- /trunk/sources/HeuristicLab.sln	(revision 1401)
+++ /trunk/sources/HeuristicLab.sln	(revision 1402)
@@ -1227,5 +1227,6 @@
 		{F0F97CBA-61A2-471C-9973-F099202B3BE5}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{F0F97CBA-61A2-471C-9973-F099202B3BE5}.Release|Any CPU.Build.0 = Release|Any CPU
-		{F0F97CBA-61A2-471C-9973-F099202B3BE5}.Release|x86.ActiveCfg = Release|Any CPU
+		{F0F97CBA-61A2-471C-9973-F099202B3BE5}.Release|x86.ActiveCfg = Release|x86
+		{F0F97CBA-61A2-471C-9973-F099202B3BE5}.Release|x86.Build.0 = Release|x86
 		{F0F97CBA-61A2-471C-9973-F099202B3BE5}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{F0F97CBA-61A2-471C-9973-F099202B3BE5}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -1290,5 +1291,6 @@
 		{9076697B-C151-46CD-95BC-1D059492B478}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{9076697B-C151-46CD-95BC-1D059492B478}.Release|Any CPU.Build.0 = Release|Any CPU
-		{9076697B-C151-46CD-95BC-1D059492B478}.Release|x86.ActiveCfg = Release|Any CPU
+		{9076697B-C151-46CD-95BC-1D059492B478}.Release|x86.ActiveCfg = Release|x86
+		{9076697B-C151-46CD-95BC-1D059492B478}.Release|x86.Build.0 = Release|x86
 		{9076697B-C151-46CD-95BC-1D059492B478}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{9076697B-C151-46CD-95BC-1D059492B478}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -1305,5 +1307,6 @@
 		{D59E852C-F205-4647-8C05-EB9ED1CF44E9}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{D59E852C-F205-4647-8C05-EB9ED1CF44E9}.Release|Any CPU.Build.0 = Release|Any CPU
-		{D59E852C-F205-4647-8C05-EB9ED1CF44E9}.Release|x86.ActiveCfg = Release|Any CPU
+		{D59E852C-F205-4647-8C05-EB9ED1CF44E9}.Release|x86.ActiveCfg = Release|x86
+		{D59E852C-F205-4647-8C05-EB9ED1CF44E9}.Release|x86.Build.0 = Release|x86
 		{D59E852C-F205-4647-8C05-EB9ED1CF44E9}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{D59E852C-F205-4647-8C05-EB9ED1CF44E9}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -1320,5 +1323,6 @@
 		{AC3D84FF-F0D7-43F0-9C99-9F8DBE087E2C}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{AC3D84FF-F0D7-43F0-9C99-9F8DBE087E2C}.Release|Any CPU.Build.0 = Release|Any CPU
-		{AC3D84FF-F0D7-43F0-9C99-9F8DBE087E2C}.Release|x86.ActiveCfg = Release|Any CPU
+		{AC3D84FF-F0D7-43F0-9C99-9F8DBE087E2C}.Release|x86.ActiveCfg = Release|x86
+		{AC3D84FF-F0D7-43F0-9C99-9F8DBE087E2C}.Release|x86.Build.0 = Release|x86
 		{AC3D84FF-F0D7-43F0-9C99-9F8DBE087E2C}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{AC3D84FF-F0D7-43F0-9C99-9F8DBE087E2C}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -1335,5 +1339,6 @@
 		{5CDACE54-5FB2-4344-A21C-963F63CB7C2B}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{5CDACE54-5FB2-4344-A21C-963F63CB7C2B}.Release|Any CPU.Build.0 = Release|Any CPU
-		{5CDACE54-5FB2-4344-A21C-963F63CB7C2B}.Release|x86.ActiveCfg = Release|Any CPU
+		{5CDACE54-5FB2-4344-A21C-963F63CB7C2B}.Release|x86.ActiveCfg = Release|x86
+		{5CDACE54-5FB2-4344-A21C-963F63CB7C2B}.Release|x86.Build.0 = Release|x86
 		{5CDACE54-5FB2-4344-A21C-963F63CB7C2B}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{5CDACE54-5FB2-4344-A21C-963F63CB7C2B}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -1350,5 +1355,6 @@
 		{4D5A2A16-66C2-431D-9AA3-BD3041E64B84}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{4D5A2A16-66C2-431D-9AA3-BD3041E64B84}.Release|Any CPU.Build.0 = Release|Any CPU
-		{4D5A2A16-66C2-431D-9AA3-BD3041E64B84}.Release|x86.ActiveCfg = Release|Any CPU
+		{4D5A2A16-66C2-431D-9AA3-BD3041E64B84}.Release|x86.ActiveCfg = Release|x86
+		{4D5A2A16-66C2-431D-9AA3-BD3041E64B84}.Release|x86.Build.0 = Release|x86
 		{4D5A2A16-66C2-431D-9AA3-BD3041E64B84}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{4D5A2A16-66C2-431D-9AA3-BD3041E64B84}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU