Index: branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/PersistenceConfigurationForm.cs
===================================================================
--- branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/PersistenceConfigurationForm.cs	(revision 1404)
+++ branches/New Persistence Exploration/Persistence/HeuristicLab.Persistence.GUI/PersistenceConfigurationForm.cs	(revision 1405)
@@ -27,9 +27,9 @@
       initializeDecomposerList();
       initializeFormatterPages();
-      ConfigurationService.Instance.DefineConfiguration(
-        XmlFormat.Instance,
-        new Configuration(
-          new Dictionary<Type, IFormatter> {{typeof (bool), new FakeBoolean2XmlFormatter()}},
-          new List<IDecomposer>{new ArrayDecomposer(), new DictionaryDecomposer()}));          
+      //ConfigurationService.Instance.DefineConfiguration(
+      //  XmlFormat.Instance,
+       // new Configuration(
+        //  new Dictionary<Type, IFormatter> {{typeof (bool), new FakeBoolean2XmlFormatter()}},
+         // new List<IDecomposer>{new ArrayDecomposer(), new DictionaryDecomposer()}));          
       initializeFromConfigurationService();
     }
@@ -61,9 +61,8 @@
                       row.Cells["Active"].Value = true;
                       break;
-                    }                    
+                    }
                   }                                
                 }
-              }
-              break;
+              }              
             }
           }
@@ -279,4 +278,5 @@
   }
 
+  [EmptyStorableClass]
   public class FakeBoolean2XmlFormatter : IFormatter {    
 
@@ -294,4 +294,5 @@
   }  
 
+  [EmptyStorableClass]
   public class Int2XmlFormatter: IFormatter {
     public Type Type { get { return typeof (int);  } }
Index: branches/New Persistence Exploration/Persistence/Persistence/Default/Decomposers/ArrayDecomposer.cs
===================================================================
--- branches/New Persistence Exploration/Persistence/Persistence/Default/Decomposers/ArrayDecomposer.cs	(revision 1404)
+++ branches/New Persistence Exploration/Persistence/Persistence/Default/Decomposers/ArrayDecomposer.cs	(revision 1405)
@@ -1,8 +1,10 @@
 ﻿using System;
 using System.Collections;
+using HeuristicLab.Persistence.Core;
 using HeuristicLab.Persistence.Interfaces;
 
 namespace HeuristicLab.Persistence.Default.Decomposers {
   
+  [EmptyStorableClass]
   public class ArrayDecomposer : IDecomposer {
 
Index: branches/New Persistence Exploration/Persistence/Persistence/Default/Decomposers/DictionaryDecomposer.cs
===================================================================
--- branches/New Persistence Exploration/Persistence/Persistence/Default/Decomposers/DictionaryDecomposer.cs	(revision 1404)
+++ branches/New Persistence Exploration/Persistence/Persistence/Default/Decomposers/DictionaryDecomposer.cs	(revision 1405)
@@ -1,8 +1,10 @@
 ﻿using System;
 using System.Collections;
+using HeuristicLab.Persistence.Core;
 using HeuristicLab.Persistence.Interfaces;
 
-namespace HeuristicLab.Persistence.Default.Decomposers {  
+namespace HeuristicLab.Persistence.Default.Decomposers {
 
+  [EmptyStorableClass]
   public class DictionaryDecomposer : IDecomposer {
 
Index: branches/New Persistence Exploration/Persistence/Persistence/Default/Decomposers/EnumerableDecomposer.cs
===================================================================
--- branches/New Persistence Exploration/Persistence/Persistence/Default/Decomposers/EnumerableDecomposer.cs	(revision 1404)
+++ branches/New Persistence Exploration/Persistence/Persistence/Default/Decomposers/EnumerableDecomposer.cs	(revision 1405)
@@ -2,8 +2,10 @@
 using System.Collections;
 using System.Reflection;
+using HeuristicLab.Persistence.Core;
 using HeuristicLab.Persistence.Interfaces;
 
 namespace HeuristicLab.Persistence.Default.Decomposers {
-  
+
+  [EmptyStorableClass]
   public class EnumerableDecomposer : IDecomposer {
 
Index: branches/New Persistence Exploration/Persistence/Persistence/Default/Decomposers/KeyValuePairDecomposer.cs
===================================================================
--- branches/New Persistence Exploration/Persistence/Persistence/Default/Decomposers/KeyValuePairDecomposer.cs	(revision 1404)
+++ branches/New Persistence Exploration/Persistence/Persistence/Default/Decomposers/KeyValuePairDecomposer.cs	(revision 1405)
@@ -2,8 +2,10 @@
 using System.Collections;
 using System.Collections.Generic;
+using HeuristicLab.Persistence.Core;
 using HeuristicLab.Persistence.Interfaces;
 
 namespace HeuristicLab.Persistence.Default.Decomposers {
-  
+
+  [EmptyStorableClass]
   public class KeyValuePairDecomposer : IDecomposer {    
 
Index: branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Compact/DoubleArray2XmlFormatters.cs
===================================================================
--- branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Compact/DoubleArray2XmlFormatters.cs	(revision 1404)
+++ branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Compact/DoubleArray2XmlFormatters.cs	(revision 1405)
@@ -1,6 +1,8 @@
 ﻿using System;
+using HeuristicLab.Persistence.Core;
 
 namespace HeuristicLab.Persistence.Default.Xml.Compact {
 
+  [EmptyStorableClass]
   public class DoubleArray2XmlFormatter : NumberArray2XmlFormatter {
 
@@ -20,5 +22,5 @@
   }
 
-
+  [EmptyStorableClass]
   public class Double2DArray2XmlFormatter : DoubleArray2XmlFormatter {
     public override Type Type {
@@ -29,5 +31,5 @@
   }
 
-
+  [EmptyStorableClass]
   public class Double3DArray2XmlFormatter : DoubleArray2XmlFormatter {
     public override Type Type {
Index: branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Compact/DoubleList2XmlFormatter.cs
===================================================================
--- branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Compact/DoubleList2XmlFormatter.cs	(revision 1404)
+++ branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Compact/DoubleList2XmlFormatter.cs	(revision 1405)
@@ -2,7 +2,9 @@
 using System.Collections.Generic;
 using System;
+using HeuristicLab.Persistence.Core;
 
 namespace HeuristicLab.Persistence.Default.Xml.Compact {
-  
+
+  [EmptyStorableClass]
   public class DoubleList2XmlFormatter : NumberEnumeration2XmlFormatter {
 
Index: branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Compact/IntArray2XmlFormatters.cs
===================================================================
--- branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Compact/IntArray2XmlFormatters.cs	(revision 1404)
+++ branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Compact/IntArray2XmlFormatters.cs	(revision 1405)
@@ -1,6 +1,8 @@
 ﻿using System;
+using HeuristicLab.Persistence.Core;
 
 namespace HeuristicLab.Persistence.Default.Xml.Compact {
-                                                              
+
+  [EmptyStorableClass]
   public class IntArray2XmlFormatter : NumberArray2XmlFormatter {
 
@@ -21,4 +23,5 @@
 
 
+  [EmptyStorableClass]
   public class Int2DArray2XmlFormatter : IntArray2XmlFormatter {
     public override Type Type {
@@ -30,4 +33,5 @@
 
 
+  [EmptyStorableClass]
   public class Int3DArray2XmlFormatter : IntArray2XmlFormatter {
     public override Type Type {
Index: branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Compact/IntList2XmlFormatter.cs
===================================================================
--- branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Compact/IntList2XmlFormatter.cs	(revision 1404)
+++ branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Compact/IntList2XmlFormatter.cs	(revision 1405)
@@ -2,7 +2,9 @@
 using System.Collections.Generic;
 using System;
+using HeuristicLab.Persistence.Core;
 
 namespace HeuristicLab.Persistence.Default.Xml.Compact {
-  
+
+  [EmptyStorableClass]
   public class IntList2XmlFormatter : NumberEnumeration2XmlFormatter {
 
Index: branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Primitive/Boolean2XmlFormatter.cs
===================================================================
--- branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Primitive/Boolean2XmlFormatter.cs	(revision 1404)
+++ branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Primitive/Boolean2XmlFormatter.cs	(revision 1405)
@@ -1,7 +1,9 @@
 ﻿using System;
+using HeuristicLab.Persistence.Core;
 using HeuristicLab.Persistence.Interfaces;
 
 namespace HeuristicLab.Persistence.Default.Xml.Primitive {
-  
+
+  [EmptyStorableClass]
   public class Boolean2XmlFormatter : IFormatter {    
 
Index: branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Primitive/DateTime2XmlFormatter.cs
===================================================================
--- branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Primitive/DateTime2XmlFormatter.cs	(revision 1404)
+++ branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Primitive/DateTime2XmlFormatter.cs	(revision 1405)
@@ -1,7 +1,9 @@
 ﻿using System;
+using HeuristicLab.Persistence.Core;
 using HeuristicLab.Persistence.Interfaces;
 
 namespace HeuristicLab.Persistence.Default.Xml.Primitive {
-  
+
+  [EmptyStorableClass]
   public class DateTime2XmlFormatter : IFormatter {    
 
Index: branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Primitive/Double2XmlFormatter.cs
===================================================================
--- branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Primitive/Double2XmlFormatter.cs	(revision 1404)
+++ branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Primitive/Double2XmlFormatter.cs	(revision 1405)
@@ -1,8 +1,10 @@
 ﻿using System;
 using System.Globalization;
+using HeuristicLab.Persistence.Core;
 using HeuristicLab.Persistence.Interfaces;
 
 namespace HeuristicLab.Persistence.Default.Xml.Primitive {
 
+  [EmptyStorableClass]
   public class Double2XmlFormatter : IFormatter {    
 
Index: branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Primitive/Int2XmlFormatter.cs
===================================================================
--- branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Primitive/Int2XmlFormatter.cs	(revision 1404)
+++ branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Primitive/Int2XmlFormatter.cs	(revision 1405)
@@ -1,7 +1,9 @@
 ﻿using System;
+using HeuristicLab.Persistence.Core;
 using HeuristicLab.Persistence.Interfaces;
 
 namespace HeuristicLab.Persistence.Default.Xml.Primitive {
 
+  [EmptyStorableClass]
   public class Int2XmlFormatter : IFormatter {
 
Index: branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Primitive/Sting2XmlFormatter.cs
===================================================================
--- branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Primitive/Sting2XmlFormatter.cs	(revision 1404)
+++ branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/Primitive/Sting2XmlFormatter.cs	(revision 1405)
@@ -1,8 +1,10 @@
 ﻿using System;
 using System.Text;
+using HeuristicLab.Persistence.Core;
 using HeuristicLab.Persistence.Interfaces;
 
 namespace HeuristicLab.Persistence.Default.Xml.Primitive {
 
+  [EmptyStorableClass]
   public class String2XmlFormatter : IFormatter {
 
Index: branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/XmlFormat.cs
===================================================================
--- branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/XmlFormat.cs	(revision 1404)
+++ branches/New Persistence Exploration/Persistence/Persistence/Default/Xml/XmlFormat.cs	(revision 1405)
@@ -1,8 +1,10 @@
 ﻿using HeuristicLab.Persistence.Interfaces;
+using HeuristicLab.Persistence.Core;
 
 namespace HeuristicLab.Persistence.Default.Xml {
 
-  public class XmlFormat : IFormat {
-    public string Name { get { return "XML"; } }
+  [EmptyStorableClass]
+  public class XmlFormat : Format {
+    public override string Name { get { return "XML"; } }
     public static readonly XmlFormat Instance = new XmlFormat();
   }